/*
 * Updated 2005/11/27
 * 
 * Mail : info@graviness.com
 * Home : http://www.graviness.com/
 */



/**
 * Aj[VǗNXD
 */
function class__AnimationManager__(window) {
	var className = Object.getClassName(arguments.callee);

	var $destroyListeners = Object.privateId();

	var F = window[className] = function() {
		this.ownerAnimations = new Array();
		this.ownerAnimationMap = new Array();

		this.ownerAnimationIndex = 0;

		this[$destroyListeners] = null;
	};

	var FP = Object.getPrototype(arguments.callee, window);

	/**
	 * Aj[VXPW[ɒǉ܂D
	 * 
	 * void add(AbstractAnimation animation)
	 * animationX^[ĝ́C
	 * OɒǉAj[VI_łD
	 * JnAj[Ṽ\bhŒǉ܂D
	 * <!-- ̏ꍇCÕAj[V͕Kv܂D -->
	 * 
	 * void add(AbstractAnimation animation, AbstractAnimation ownerAnimation)
	 * animationJn̂́CownerAnimationŏIt[ɒB_łD
	 * 
	 * void add(AbstractAnimation animation, int frame)
	 * animationJn̂
	 * OɒǉAj[VframeʒuɒB_łD
	 * 
	 * void add(AbstractAnimation animation, AbstractAnimation ownerAnimation, int frame)
	 * animationJn̂́CownerAnimationframeɒB_łD
	 * frame-1w肵ꍇCanimationJn̂
	 * ownerAnimationŏIt[ɒB_ɂȂ܂D
	 */
	FP.add = function() {
		var a = arguments;
		switch (a.length) {
			case 1 : {
				var animation = a[0];

				// X^[gAj[Vo^
				if (this.ownerAnimationIndex == 0) {
					if (animation._manager != null
						&& animation._manager != this)
						// }l[Wւ̑do^
						return void(window.errorMessage("MultipleManagerResistersException@" + className + "#add(AbstractAnimation)"));

					if (animation.getFinalFrame() == -1)
						// It[ݒ
						return void(window.errorMessage("IllegalStateException@" + className + "#add(AbstractAnimation)"));

					if (animation._managerIndices == null)
						animation._managerIndices = new Array();

					animation._manager = this;
					animation._managerIndices.push(this.ownerAnimationIndex++);

					this.ownerAnimations[0] = animation;
					this.ownerAnimationMap[0] = new Object();

					return;
				}

				// Oɓo^ꂽAj[V̍ŏIt[ɓo^
				else {
					this.add(
						animation,
						this.ownerAnimations[this.ownerAnimationIndex - 1],
						-1);

					return;
				}
			}
			case 2 : {
				// AbstractAnimation animation, int frame
				// AbstractAnimation animation, AbstractAnimation ownerAnimation

				if (typeof a[1] == "number") {
					var animation = a[0];
					var frame = Math.floor(a[1]);

					// Oɓo^ꂽAj[Vframeʒuɓo^
					this.add(
						animation,
						this.ownerAnimations[this.ownerAnimationIndex - 1],
						frame);

					return;
				} else {
					var animation = a[0];
					var ownerAnimation = a[1];

					// ownerAnimation̍ŏIt[ɓo^
					this.add(animation, ownerAnimation, -1);

					return;
				}
			}
			case 3 : {
				var animation = a[0];
				var ownerAnimation = a[1];
				var frame = Math.floor(a[2]);

				// o^Aj[Vւ̒ǉ
				if (ownerAnimation._manager == null)
					return void(window.errorMessage("UnregistedException@" + className + "#add(AbstractAnimation, AbstractAnimation, int)"));

				// }l[Wւ̑do^
				if (ownerAnimation._manager != this)
					return void(window.errorMessage("MultipleManagerResistersException@" + className + "#add(AbstractAnimation, AbstractAnimation, int)"));

				// It[ݒ̃Aj[Vւ̓o^
				if (ownerAnimation.getFinalFrame() == -1)
					return void(window.errorMessage("IllegalStateException@" + className + "#add(AbstractAnimation, AbstractAnimation, int)"));

				animation._manager = this;
				if (animation._managerIndices == null)
					animation._managerIndices = new Array();
				var managerIndex = this.ownerAnimationIndex++;
				animation._managerIndices.push(managerIndex);

				this.ownerAnimations[managerIndex] = animation;
				this.ownerAnimationMap[managerIndex] = new Object();

				var p = this.ownerAnimationMap[
					ownerAnimation._managerIndices[
						ownerAnimation._managerIndices.length - 1]];

				if (p[String(frame)] === void 0)
					p[String(frame)] = new Array();

				p[String(frame)].push(animation);

				return;
			}
			default :
				return void(window.errorMessage("IllegalArgumentsException@" + className + "#add(...)"));
		}
	};

	/**
	 * eAj[Vɓo^ĂqAj[V̎擾D
	 * 
	 * ownerAnimationframeʒuŎsAj[V擾܂D
	 * 
	 * @return	sׂAj[VCX^XD݂ȂꍇCnullD
	 */
	FP.getAnimations = function(ownerAnimation, frame) {
		// o^
		if (ownerAnimation._manager == null
			|| ownerAnimation._manager != this)
			return void(window.errorMessage("UnregistedException@" + className + "#getAnimations(AbstractAnimation, int)"));

		if (ownerAnimation._managerCurrentIndex
			>= ownerAnimation._managerIndices.length)
			return null;

		var animations = this.ownerAnimationMap[
				ownerAnimation._managerIndices[
					ownerAnimation._managerCurrentIndex]][String(frame)];

		if (animations !== void 0) {
			ownerAnimation._managerCurrentIndex++;
			return animations;
		} else {
			return null;
		}
	};

	/**
	 * Aj[V̊JnD
	 * 
	 * ŏɓo^ꂽAj[VJn܂D
	 */
	FP.start = function() {
		this.ownerAnimations[0].start();
	};

	/**
	 * Aj[V̏ID
	 * 
	 * o^ꂽAj[VSďICIs܂D
	 */
	FP.stop = function() {
		for (var i = 0; i < this.ownerAnimations.length; i++) {
			this.ownerAnimations[i].stop();
		}

		if (this[$destroyListeners] != null) {
			var ls = this[$destroyListeners];
			for (var i = 0; i < ls.length; i++)
				if (ls[i] != null)
					ls[i]();
		}
	};

	/**
	 * Aj[VIǉD
	 * 
	 * {@link #destroy}\bhĂяoɂŒǉ֐sD
	 */
	FP.addDestroyListener = function(listener) {
		if (this[$destroyListeners] == null)
			this[$destroyListeners] = new Array();

		this[$destroyListeners].push(listener);
	};

	/**
	 * Aj[VI폜D
	 */
	FP.removeDestroyListener = function(listener) {
		var ls = this[$destroyListeners];

		if (ls == null) {
//			window.errorMessage("IllegalStateException@" + className + "#removeDestroyListener(function)");
			return false;
		}

		for (var i = 0; i < ls.length; i++) {
			if (ls[i] == null)
				continue;

			if (ls[i] === listener) {
				ls[i] = null;
				return true;
			}
		}

		return false;
	};
} class__AnimationManager__(window);
