/*
 * Updated 2005/11/27
 * 
 * Mail : info@graviness.com
 * Home : http://www.graviness.com/
 */



/**
 * ~^Aj[VNXilς݁jD
 * {@link AbstractEasingAnimation}NX̃TuNXłD
 * 
 *  {
 * x(t) = r * cos( * t + ) + x_c
 * y(t) = r * sin( * t + ) + y_c
 * 
 * r	: a
 * 	: px
 * 	: ʑ
 * x_c	: ]SxW
 * y_c	: ]SyW
 * 
 *  Wn
 * \ w
 * b
 * 
 * x
 */
function class__CircleAnimation__extends__AbstractEasingAnimation__(window) {
	var className = Object.getClassName(arguments.callee);

	/**
	 * Constructor()
	 */
	var F = window[className] = function() {
		this.__super__(); // super();

		this.element = null;

		this.setRadius(100.0);
		this.setOmega(2.0 * PI);
		this.setFai(0.0);
		this.setCenterPosition(0.0, 0.0);
	};

	var FP = Object.getPrototype(arguments.callee, window);

	var PI = Math.PI;

	/**
	 * ړΏہD
	 */
	FP.setElement = function(element) {
		this.element = element;
	}

	/**
	 * 
	 */
	FP.getElement = function() {
		return this.element;
	}

	/**
	 * ]aݒD
	 */
	FP.setRadius = function(radius) {
		this.r = radius;
	};

	/**
	 * 
	 */
	FP.getRadius = function() {
		return this.r;
	};

	/**
	 * pxւݒD
	 *  = 2΂̂Ƃ1C = 4΂̂Ƃ2D
	 */
	FP.setOmega = function(omega) {
		this.omega = omega;
	};

	/**
	 * pxւ擾D
	 */
	FP.getOmega = function() {
		return this.omega;
	};

	/**
	 * T̐ݒD
	 * pxւƎT̊֌W : T = 2 / 
	 */
	FP.setT = function(T) {
		this.omega = 2.0 * PI / T;
	};

	/**
	 * T̎擾D
	 */
	FP.getT = function() {
		return (2.0 * PI) / this.omega;
	};

	/**
	 * ʑӂ̐ݒD
	 */
	FP.setFai = function(fai) {
		this.fai = fai;
	};

	/**
	 * ʑӂ̎擾D
	 */
	FP.getFai = function(fai) {
		return this.fai;
	};

	/**
	 * ]̒SʒuݒD
	 * void setCenterPosition(Point centerPosition);
	 * void setCenterPosition(number centerX, number centerY);
	 */
	FP.setCenterPosition = function() {
		var a = arguments;
		switch (a.length) {
			case 1 :
				this.cx = a[0].x;
				this.cy = a[0].y;
				return;
			case 2 :
				this.cx = a[0];
				this.cy = a[1];
				return;
			default :
				return void(window.errorMessage("IllegalArgumentsException@"
					+ className + "#setCenterPosition(...)"));
		}
	};

	FP.getCenterX = function() {
		return this.cx;
	};

	FP.getCenterY = function() {
		return this.cy;
	};

	FP.getCenterPosition = function() {
		return new Point(this.cx, this.cy);
	};

	FP.init = function() {
	};

	FP.emove = function(currentFrame, finalFrame, t, s) {
		var theta = this.omega * s + this.fai;

		this.element.setPosition(
			this.r * Math.cos(theta) + this.cx,
			this.r * Math.sin(theta) + this.cy);

		return true;
	};

	FP.destroy = function() {
	};
} class__CircleAnimation__extends__AbstractEasingAnimation__(window);
