/*
 * Updated 2008/11/28
 * Ver. 1.00
 * charset = Shift-JIS
 * import graviness-sys-Common.js
 * 
 * Mail : info@graviness.com
 * Home : http://www.graviness.com/
 * 
 * MathNX̃NX\bhmersenneTwisterRandom\bhǉ܂D
 * 
 * Ref.
 * 	http://www.math.sci.hiroshima-u.ac.jp/~m-mat/MT/mt.html
 */



/**
 * [탁ZkEcCX^NXD
 * 
 * [@̕Wł郁ZkEcCX^܂D
 * 
 * 32rbg^̈l{ƂC46rbg^lC
 * _^̈l𐶐܂D
 * ̏ɂ́C̐gp܂CKvɉ
 * zpCӃrbg̒lgp邱Ƃł܂D
 * 
 * ̃NX͈ȉ̃TCg(C\[X)JavaScriptڐAłłD
 * http://www.math.sci.hiroshima-u.ac.jp/~m-mat/MT/MT2002/CODES/mt19937ar.c
 * (http://www.math.sci.hiroshima-u.ac.jp/~m-mat/MT/mt.html)
 * OC^tF[X́CJavajava.util.RandomNXQlɎĂ܂D
 * http://sdc.sun.co.jp/java/docs/j2se/1.4/ja/docs/ja/api/java/util/Random.html
 * 
 * \́CrgCMath.random̖2̈łC
 * ̕i͓YTCgɎʂłD
 * 
 * gp)
 * // CX^X𐶐Cݎŏ܂D
 * var mt = new MersenneTwister(new Date().getTime());
 * for (var i = 0; i < 1000; ++i) {
 * 	// 32rbg^̈l
 * 	var randomNumber = mt.nextInteger();
 * }
 */
function class__MersenneTwister__(window)
{
	var className = Object.getClassName(arguments.callee);

	var $next = Object.privateId();

	var N = 624;
	var M = 397;
	var MAG01 = [0x0, 0x9908b0df];

	/**
	 * VWFl[^𐶐܂D
	 * ɉV[hݒ肵܂D
	 * 
	 * @param (None)	VWFl[^𐶐܂D
	 * V[h͌ݎgp܂D
	 * @see Date#getTime()
	 * ---
	 * @param number	
	 * @see #setSeed(number)
	 * ---
	 * @param number[]	
	 * @see #setSeed(number[])
	 * ---
	 * @param number, number, ...	
	 * @see #setSeed(number, number, ...)
	 */
	var F = window[className] = function()
	{
		this.mt = new Array(N);
		this.mti = N + 1;

		var a = arguments;
		switch (a.length) {
		case 0:
			this.setSeed(new Date().getTime());
			break;
		case 1:
			this.setSeed(a[0]);
			break;
		default:
			var seeds = new Array();
			for (var i = 0; i < a.length; ++i) {
				seeds.push(a[i]);
			}
			this.setSeed(seeds);
			break;
		}
	};

	var FP = Object.getPrototype(arguments.callee, window);

	/**
	 * WFl[^̃V[hݒ肵܂D
	 * 
	 * @param number	P̐lgpC
	 * 	WFl[^̃V[hݒ肵܂D
	 * ---
	 * @param number[]	̐lgpC
	 * 	WFl[^̃V[hݒ肵܂D
	 * ---
	 * @param number, number, ...	̐lgpC
	 * 	WFl[^̃V[hݒ肵܂D
	 */
	FP.setSeed = function()
	{
		var a = arguments;
		switch (a.length) {
		case 1:
			if (a[0].constructor === Number) {
				this.mt[0]= a[0];
				for (var i = 1; i < N; ++i) {
					var s = this.mt[i - 1] ^ (this.mt[i - 1] >>> 30);
					this.mt[i] = ((1812433253 * ((s & 0xffff0000) >>> 16))
							<< 16)
						+ 1812433253 * (s & 0x0000ffff)
						+ i;
				}
				this.mti = N;
				return;
			}

			this.setSeed(19650218);

			var l = a[0].length;
			var i = 1;
			var j = 0;

			for (var k = N > l ? N : l; k != 0; --k) {
				var s = this.mt[i - 1] ^ (this.mt[i - 1] >>> 30)
				this.mt[i] = (this.mt[i]
						^ (((1664525 * ((s & 0xffff0000) >>> 16)) << 16)
							+ 1664525 * (s & 0x0000ffff)))
					+ a[0][j]
					+ j;
				if (++i >= N) {
					this.mt[0] = this.mt[N - 1];
					i = 1;
				}
				if (++j >= l) {
					j = 0;
				}
			}

			for (var k = N - 1; k != 0; --k) {
				var s = this.mt[i - 1] ^ (this.mt[i - 1] >>> 30);
				this.mt[i] = (this.mt[i]
						^ (((1566083941 * ((s & 0xffff0000) >>> 16)) << 16)
							+ 1566083941 * (s & 0x0000ffff)))
					- i;
				if (++i >= N) {
					this.mt[0] = this.mt[N-1];
					i = 1;
				}
			}

			this.mt[0] = 0x80000000;
			return;
		default:
			var seeds = new Array();
			for (var i = 0; i < a.length; ++i) {
				seeds.push(a[i]);
			}
			this.setSeed(seeds);
			return;
		}
	};

	/**
	 * ̋[𐶐܂D
	 * @param bits	o͒l̗Lrbgw肵܂D
	 * 	0 &lt; bits &lt;= 32Ŏw肵܂D
	 * @param ̋[D
	 */
	FP[$next] = function(bits)
	{
		if (this.mti >= N) {
			var x = 0;

			for (var k = 0; k < N - M; ++k) {
				x = (this.mt[k] & 0x80000000) | (this.mt[k + 1] & 0x7fffffff);
				this.mt[k] = this.mt[k + M] ^ (x >>> 1) ^ MAG01[x & 0x1];
			}
			for (var k = N - M; k < N - 1; ++k) {
				x = (this.mt[k] & 0x80000000) | (this.mt[k + 1] & 0x7fffffff);
				this.mt[k] = this.mt[k + (M - N)] ^ (x >>> 1) ^ MAG01[x & 0x1];
			}
			x = (this.mt[N - 1] & 0x80000000) | (this.mt[0] & 0x7fffffff);
			this.mt[N - 1] = this.mt[M - 1] ^ (x >>> 1) ^ MAG01[x & 0x1];

			this.mti = 0;
		}

		var y = this.mt[this.mti++];
		y ^= y >>> 11;
		y ^= (y << 7) & 0x9d2c5680;
		y ^= (y << 15) & 0xefc60000;
		y ^= y >>> 18;
		return y >>> (32 - bits);
	};

	/**
	 * lzboolean^̋[Ԃ܂D
	 * @return true or falseD
	 */
	FP.nextBoolean = function()
	{
		return this[$next](1) == 1;
	};

	/**
	 * lz̕32rbg^̋[Ԃ܂D
	 * @return 32rbg^̋[ŁC0ȏ4294967295ȉłD
	 */
	FP.nextInteger = function()
	{
		return this[$next](32);
	};

	/**
	 * lz̕46rbg^̋[Ԃ܂D
	 * @return 46rbg^̋[ŁC0ȏ70368744177663ȉłD
	 */
	FP.nextLong = function()
	{
		// NOTE: 48rbgȏŌvZʂD
		// (46 - 32) = 14 = [7] + [7], 32 - [7] = [25], 32 - [7] = [25]
		// 2^(46 - [25]) = 2^21 = [2097152]
		return this[$next](25) * 2097152 + this[$next](25);
	};

	/**
	 * 0.0`1.0͈̔͂ňlz32rbgx[X
	 * _^̋[Ԃ܂D
	 * @return JԂ[0.0 1.0)łD
	 */
	FP.nextFloat = function()
	{
		return this[$next](32) / 4294967296.0; // 2^32
	};

	/**
	 * 0.0`1.0͈̔͂ňlz46rbgx[X
	 * _^̋[Ԃ܂D
	 * @return JԂ[0.0 1.0)łD
	 */
	FP.nextDouble = function()
	{
		return (this[$next](25) * 2097152 + this[$next](25))
			/ 70368744177664.0; // 2^46
	};

} class__MersenneTwister__(window);



/**
 * [ɃZkEcCX^gpCJ[0 1.0)
 * _^̋[𐶐܂D
 * Math.randomƓlɎgp܂D
 * 
 * gp)
 * // 0ȏ1菬s_^̒l𐶐܂D
 * var r = Math.mersenneTwisterRandom();
 */
Math.mersenneTwisterRandom = function()
{
	Math.__MERSENNE_TWISTER__ = new MersenneTwister();

	return function() {
		return Math.__MERSENNE_TWISTER__.nextFloat();
	}
}();
